<?php

namespace SM\Service;

use SM\Factory\Sm00001101RelatorioCustomizavelPropostaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use SM\Service\FindService;

class Sm00001101RelatorioCustomizavelPropostaService
{

    protected $connection;
    protected $relatorioCustomizavelPropostaFactory;
    protected $environment;
    protected $newCode;
    protected $FindService;
    
    public function __construct(Sm00001101RelatorioCustomizavelPropostaFactory $relatorioCustomizavelPropostaFactory, Environment $environment, NewCode $newCode, EntityManager $entityManager, FindService $FindService)
    {
        $this->relatorioCustomizavelPropostaFactory = $relatorioCustomizavelPropostaFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
        $this->FindService                  = $FindService;
    }

    public function getRelatorioCustomizavelProposta($parametros)
    {
        $cont = 0;
        $filtro = '';

        if (isset($parametros["NRSEQORCAMENTO"])) {
            $proposta = $this->FindService->formatarArray($parametros["NRSEQORCAMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.NRSEQORCAMENTO IN ($proposta) ";
            $cont++;
        }

        if (isset($parametros["NRPARCNEGOCIO"])) {
            $nrparcnegocio = $this->FindService->formatarArray($parametros["NRPARCNEGOCIO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.NRPARCNEGOCIO IN ($nrparcnegocio) ";
            $cont++;
        }
        
        if (isset($parametros["IDSITUACAOORCAMENTO"])) {
            $idsituacao = $this->FindService->formatarArray($parametros["IDSITUACAOORCAMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.IDSITUACAOORCAMENTO IN ($idsituacao) ";
            $cont++;
        }

        if (isset($parametros["CDFILIAL"])) {
            $filial = $this->FindService->formatarArray($parametros["CDFILIAL"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.CDFILIAL IN ($filial) ";
            $cont++;
        }

        if (isset($parametros["NRORCAMENTOMODELO"])) {
            $orcamentoModelo = $this->FindService->formatarArray($parametros["NRORCAMENTOMODELO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.NRORCAMENTOMODELO IN ($orcamentoModelo) ";
            $cont++;
        }

        if (isset($parametros["NRTIPOORCAMENTO"])) {
            $nrTipoOrcamento = $this->FindService->formatarArray($parametros["NRTIPOORCAMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.NRTIPOORCAMENTO IN ($nrTipoOrcamento) ";
            $cont++;
        }

        if (isset($parametros["CDOPERRESPONSAVEL"])) {
            $operadorResponsavel = $this->FindService->formatarArray($parametros["CDOPERRESPONSAVEL"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.CDOPERRESPONSAVEL IN ($operadorResponsavel) ";
            $cont++;
        }
        
        if (isset($parametros["CDTPMEDIDASERV"])) {
            $tipoMedida = $this->FindService->formatarArray($parametros["CDTPMEDIDASERV"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." MEDIDA.CDTPMEDIDAVARIAVEL IN ($tipoMedida) ";
            $cont++;
        }
    
        if (isset($parametros["NRSEQINTERLOCUTOR"])) {
            $nterlocutor = $this->FindService->formatarArray($parametros["NRSEQINTERLOCUTOR"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.NRSEQINTERLOCUTOR IN ($nterlocutor) ";
            $cont++;
        }

        if (isset($parametros["NRSEQOPORT"])) {
            $nrseqoport = $this->FindService->formatarArray($parametros["NRSEQOPORT"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ORC.NRSEQOPORT IN ($nrseqoport) ";
            $cont++;
        }

        if (isset($parametros["NRVENDEDOR"])) {
            $vendedor = $this->FindService->formatarArray($parametros["NRVENDEDOR"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." VENDEDOR.NRPARCVENDEDOR IN ($vendedor) ";
            $cont++;
        }

        if (isset($parametros["CDSERVORCA"])) {
            $cdservorca = $this->FindService->formatarArray($parametros["CDSERVORCA"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMORCAMENTO.CDSERVORCA IN ($cdservorca) ";
            $cont++;
        }
        
        if (isset($parametros["IDELEMENTO"])) {
            $idelemento = $this->FindService->formatarArray($parametros["IDELEMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." ELEMENTO.IDELEMENTO IN ($idelemento) ";
            $cont++;
        }

        if (isset($parametros['DTREFORCAMENTO'])) {
            $dataInicial = $parametros['DTREFORCAMENTO'][0];
            $dataFinal = array_key_exists("1", $parametros['DTREFORCAMENTO']) ? $parametros['DTREFORCAMENTO'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " ORC.DTREFORCAMENTO BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." ORC.DTREFORCAMENTO BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        if (isset($parametros['DTACEITEORCA'])) {
            $dataInicial = $parametros['DTACEITEORCA'][0];
            $dataFinal = array_key_exists("1", $parametros['DTACEITEORCA']) ? $parametros['DTACEITEORCA'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " ORC.DTACEITEORCA BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." ORC.DTACEITEORCA BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        return $this->relatorioCustomizavelPropostaFactory->getRelatorioCustomizavelProposta($filtro);
    }

    public function getOportunidadeNegocio()
    {
        return $this->relatorioCustomizavelPropostaFactory->getOportunidadeNegocio();
    }

    public function getVendedor()
    {
        return $this->relatorioCustomizavelPropostaFactory->getVendedor();
    }

    public function getItensRelatorioCustomizavel($parametros)
    {
        $cont = 0;
        $filtro = '';

        if (isset($parametros["NRSEQORCAMENTO"])) {
            $proposta = $this->FindService->formatarArray($parametros["NRSEQORCAMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMORCAMENTO.NRSEQORCAMENTO IN ($proposta) ";
            $cont++;
        }

        if (isset($parametros["NRPARCNEGOCIO"])) {
            $nrparcnegocio = $this->FindService->formatarArray($parametros["NRPARCNEGOCIO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ORCAMENTO.NRPARCNEGOCIO IN ($nrparcnegocio) ";
            $cont++;
        }
        
        if (isset($parametros["CDSERVORCA"])) {
            $cdservorca = $this->FindService->formatarArray($parametros["CDSERVORCA"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMORCAMENTO.CDSERVORCA IN ($cdservorca) ";
            $cont++;
        }
        
        if (isset($parametros["IDELEMENTO"])) {
            $idelemento = $this->FindService->formatarArray($parametros["IDELEMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMORCAMENTO.IDELEMENTO IN ($idelemento) ";
            $cont++;
        }
        
        return $this->relatorioCustomizavelPropostaFactory->getItensRelatorioCustomizavel($filtro);
    }
}
