import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Metadata, Http } from '@zeedhi/core';
import {
    LoadingService, TextInput, IGridEvent, DialogService,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';

export class Sm00029001TipoLocalAtendimentoController {
    public adicionarTipoLocalAtendimento() {
        const grid = Metadata.getInstance<TekGrid>('tipo-local-atendimento-tek-grid');
        // const newId = (grid.datasource.total + 1).toString();
        const newId = 0;

        grid.addNewRow({ NRTIPOESTRUTURA: newId }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NMTIPOESTRUTURA_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public async salvarTipoLocalAtendimento({ event }: IGridEvent) {
        event!.preventDefault();
        const grid = Metadata.getInstance<TekGrid>('tipo-local-atendimento-tek-grid');
        const classifications = grid.getEditedRows();
        LoadingService.show();
        try {
            await Http.post('/salvarTipoLocalAtendimento', classifications);
            await grid.cancelEditedRows();
            await grid.reload();
            Utilities.showSuccessMessage();
        } catch (e) {
            Utilities.showErrorMessage(e);
        }
        LoadingService.hide();
    }

    public dialogDeletarTipoLocalAtendimento({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'Sm00029001TipoLocalAtendimentoController.deletarTipoLocalAtendimento');
    }

    public deletarTipoLocalAtendimento() {
        DialogService.hide();
        const grid = Metadata.getInstance<TekGrid>('tipo-local-atendimento-tek-grid');
        LoadingService.show();
        Http.post('/deletarTipoLocalAtendimento', grid.selectedRows).then(() => {
            grid.selectedRows = [];
            grid.cancelEditedRows();
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }
}
